<template>
	<xn-form-container
		:title="formData.id ? '编辑供货商' : '增加供货商'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="供货商名称：" name="supplierName">
				<a-input v-model:value="formData.supplierName" placeholder="请输入供货商名称" allow-clear />
			</a-form-item>
			<a-form-item label="供货商地址：" name="supplierAddress">
				<a-input v-model:value="formData.supplierAddress" placeholder="请输入供货商地址" allow-clear />
			</a-form-item>
			<a-form-item label="联系人：" name="supplierContactName">
				<a-input v-model:value="formData.supplierContactName" placeholder="请输入联系人" allow-clear />
			</a-form-item>
			<a-form-item label="手机号：" name="supplierPhone">
				<a-input v-model:value="formData.supplierPhone" placeholder="请输入手机号" allow-clear />
			</a-form-item>
			<a-form-item label="备注：" name="supplierRemark">
				<a-input v-model:value="formData.supplierRemark" placeholder="请输入备注" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="supplierForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import supplierApi from '@/api/biz/supplierApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		supplierName: [required('请输入供货商名称')],
		supplierContactName:[required('请输入联系人')],
		supplierPhone:[required('请输入手机号')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				supplierApi
					.supplierSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
